{% macro buttons_container() %}
    <div class="clearfix text-center mt-5">
        {{ caller() }}
    </div>
{% endmacro %}

{% macro next_button() %}
    <button type="submit" class="btn btn-white btn-lg-horizontal btn-lg-vertical">
        {% trans %}Continue{% endtrans %}
    </button>
{% endmacro %}

{% macro default_buttons() %}
    {% call buttons_container() %}
        {{ next_button() }}
    {% endcall %}
{% endmacro %}

{% macro ship_to_billing_address_checkbox() %}
    <div class="custom-checkbox" id="same-as-billing-wrap">
        <input type="checkbox" name="same_as_billing" id="same_as_billing" value="1"{% if request.POST.get("same_as_billing", true) %} checked{% endif %}>
        <label for="same_as_billing">{% trans %}Ship to my billing address{% endtrans %}</label>
    </div>
{% endmacro %}

{% macro address_phase_billing_well(billing_form, company_form=None, saved_address_form=None) %}
    <fieldset>
        {{ render_address_form(_("Billing address"), billing_form, "billing", True) }}
        {% if company_form and xtheme.allow_company_linkage() %}
            {{ render_company_form(
                _("Ordering for a company?"),
                _("Please fill out these fields if you are ordering for a company."),
                company_form.name, company_form.tax_number) }}
        {% endif %}
    </fieldset>
{% endmacro %}

{% macro address_phase_shipping_well(shipping_form, ship_to_billing_checkbox=True, saved_address_form=None) %}
    <div class="hidden" id="shipping-address">
        <fieldset>
            {{ render_address_form(_("Shipping address"), shipping_form, "shipping") }}
        </fieldset>
    </div>
{% endmacro %}

{% macro render_address_form(title, form, div_id, ship_to_billing_checkbox=False) %}
    {% if title %}
    <div class="row">
        <div class="order-for-company col-md-9 col-md-offset-3">
            <legend>{{ title }}</legend>
        </div>
    </div>
    {% endif %}
    <div id="{{ div_id }}" class="form-horizontal">
        {% for field in form %}
            {{ render_field(field, layout="horizontal", show_help_text=False) }}
        {% endfor %}
    </div>
    {% if ship_to_billing_checkbox %}
        {{ ship_to_billing_address_checkbox() }}
    {% endif %}
{% endmacro %}

{% macro ship_to_billing_address_checkbox() %}
    <div class="row">
        <div class="col-md-9 col-md-offset-3">
            <div class="custom-checkbox my-5">
                <input type="checkbox" name="same_as_billing" id="same_as_billing" value="1"{% if request.POST.get("same_as_billing", false) %} checked{% endif %}>
                <label for="same_as_billing">{% trans %}Ship to my billing address{% endtrans %}</label>
            </div>
        </div>
    </div>
{% endmacro %}

{% macro method_phase_service_panel(panel_title, field, has_options=true) %}
    <div class="row">
        <div class="col-md-8 col-md-push-2">
            <div class="checkout-single-method mb-5">
                <h3 class="h5 mt-0 mb-3">{{ panel_title }}</h2>
                {% if has_options %}
                    {{ field }}
                {% else %}
                    <div class="text-center">{{ _("No method is available.") }}</div>
                {% endif %}
            </div>
        </div>
    </div>
{% endmacro %}

{% macro confirm_phase_order_information(basket) %}
    <div class="checkout-basket-lines">
        {% set lines = basket.get_final_lines() %}
        {{ render_lines_table(
            lines, basket.taxful_total_price, basket.taxless_total_price, show_product_package_info=True) }}
    </div>
{% endmacro %}

{% macro render_confirm_form(form) %}
    <form role="form" method="post" action="{{ phase_urls["confirm"] }}" id="confirm_form">
        {% csrf_token %}
        {% if form.marketing %}
            {{ render_field(form.marketing) }}
        {% endif %}

        {% for field in form %}
            {% if field.name.startswith("accept_") %}
                {{ render_field(field) }}
            {% endif %}
        {% endfor %}
        {{ place_order_button() }}

        <input type="hidden" name="product_ids" value="{{ product_ids }}" />

        <hr>

    </form>
{% endmacro %}

{% macro place_order_button() %}
    <div class="text-center">
        <button type="submit" class="btn btn-white btn-lg-horizontal btn-lg-vertical">
            {% trans %}Place Order{% endtrans %}
        </button>
    </div>
{% endmacro %}

{% macro address_phase_extrajs() %}
    <script type="text/javascript">
        $(function(){
            var shouldCopyFields = false;

            function toggleAndCopyFields() {
                shouldCopyFields = $("#same_as_billing").is(":checked");

                if (shouldCopyFields) {
                    $("#shipping-address").addClass("hidden");

                    // copy all billing fields values to shipping fields
                    $("#billing :input").each(function (index, element) {
                        copyFieldValue(this);
                    });
                } else {
                    $("#shipping-address").removeClass("hidden");
                }

                $("#shipping :input")
                    .attr("readonly", shouldCopyFields)
                    .toggleClass("disabled", shouldCopyFields)
                    .trigger("change");

                // copy all billing fields values to shipping fields AGAIN
                // this is required when region app is enabled
                // as we can't guarantee the order fields are copied.
                // the region code could be copied before the country and when country
                // is changed, the region code field can be replaced by a select and
                // have options created. this way, we should copy values
                // before the `change` event trigged above and once again after
                // all fields get changed
                if (shouldCopyFields) {
                    $("#billing :input").each(function (index, element) {
                        copyFieldValue(this);
                    });
                }
            }

            function copyFieldValue(element) {
                if(!shouldCopyFields || !element)
                    return;
                var targetName = $(element).attr("id").split("-")[1];
                var $target = $("#id_shipping-" + targetName);
                $target.val(element.value);
                $target.trigger("change");
            }

            function activateCheckoutAddressCopy() {
                $("#id_shipping-country").attr("readonly", true);
                toggleAndCopyFields();
                $("#billing :input").on("input change", function (evt) {
                    copyFieldValue(evt.target);
                });
                $("#same_as_billing").on("change", toggleAndCopyFields);
            }
            activateCheckoutAddressCopy();

            // we detectec that a field could be replaced by any other input
            // in cases like regions module is injected
            // this way, we must attach the event again
            document.addEventListener("regionFieldInitialized", function (evt) {
                if ($(evt.detail.field).attr("name").indexOf("billing") >= 0) {
                    $(evt.detail.field).on("input change", function (evt) {
                        copyFieldValue(evt.target)
                    });
                }
            });
        });
    </script>
{% endmacro %}
